//Last Update Date at 10/31/2-14 at 12:30pm

//--------------------Inster After Function------------------------------
function insertAfter(referenceNode, newNode) {
    referenceNode.parentNode.insertBefore(newNode, referenceNode.nextSibling);
}

// hasClass, takes two params: element and classname
function hasClass(el, cls) {
  return el.className && new RegExp("(\\s|^)" + cls + "(\\s|$)").test(el.className);
}

function scrollToBottom() {
	window.scrollTo(0,document.body.scrollHeight);
}

function RemoveCmdBar() {
	elm = document.getElementById("CMDButtons");
	elm.style.display = "none";
}

function RemoveLinks() {
	//statusYes = document.getElementById("location");
	//console.log(statusYes);
	//if (statusYes.style.display = "none") {
	gameURL = window.location.toString()
	if (gameURL.indexOf('/mobile/') == -1){
	    // don't run, the '/mobile/' string wasn't found
	}
	else {
	    // run
		divOutput = document.getElementById("divOutput");
		vlinks = document.getElementById('divOutput').getElementsByClassName('cmdlink');
		
		vlinksLength = vlinks.length;
		//node = document.createTextNode(vlinksLength);
		//divOutput.appendChild(node);
		for (var i = 0; i < vlinksLength; i++) {
			//noder = vlinks[i].parentNode;
			//document.removeChild(noder);
			
			//var myClassName =" cmdlink";
			
			 
 
/* use like below */
// Check if an element has class "foo"
//if (hasClass(element, "foo")) {
 
  // Show an alert message if it does
  //alert("Element has the class!");
//}
			
			if (hasClass(vlinks[i], "elementmenu")) {
			
			} else {
				vlinks[i].style.display = "none";
				vlinks[i].style.height = "0px";
				vlinks[i].parentNode.style.display = "none";
				vlinks[i].parentNode.style.height = "0px";
				vlinks[i].parentNode.nextSibling.style.display = "none";
			}
			//vlinks[i].className = "";
		}
	}
}

//--------------------Em to Px Calculation------------------------------
function getElementFontSize( context ) {
    // Returns a number
    return parseFloat(
        // of the computed font-size, so in px
        getComputedStyle(
            // for the given context
            context
            // or the root <html> element
            || document.documentElement
        )
        .fontSize
    );
}
function convertRem(value) {
    return convertEm(value);
}
function convertEm(value, context) {
    return value * getElementFontSize(context);
}

//-------------------Add Map Command Function-----------------------------------

function AddMap(url) {
	//statusYes = document.getElementById("location");
	//if (statusYes.style.display = "none") {
	gameURL = window.location.toString()
	if (gameURL.indexOf('/mobile/') == -1){
	    // don't run, the '/mobile/' string wasn't found
	    elmMap = document.createElement("div");
		parentElement = document.getElementById("divOutput");
		child = parentElement.lastChild;
		insertAfter(child, elmMap);
		
		elmMap.style.width = "100%";
		elmMap.style.height = "0px";
		elmMap.style.paddingTop = "50%";
		elmMap.style.backgroundColor = "#555";
		elmMap.style.backgroundSize = "contain";
		elmMap.style.position = "relative";
		elmMap.style.backgroundImage = "url("+url+")";
		//node = document.createTextNode(url);
		//elmMap.appendChild(node);
		console.log("Non Mobile Map");
	} else {
	    // run
		elmMap = document.createElement("div");
		parentElement = document.getElementById("divOutputAlignNaN");
		child = parentElement.lastChild;
		insertAfter(child, elmMap);
		
		elmMap.style.width = "100%";
		elmMap.style.height = "0px";
		elmMap.style.paddingTop = "50%";
		elmMap.style.backgroundColor = "#555";
		elmMap.style.backgroundSize = "contain";
		elmMap.style.backgroundImage = "url("+url+")";
		//node = document.createTextNode(url);
		//elmMap.appendChild(node);
		console.log("Mobile Map");
	}
}

//-------------------Build Command Bar Function-----------------------------------

function CommandBar () {
	elmBar = document.createElement("div");
	elmBar.setAttribute("Id","CMDButtons");
	parentElement = document.getElementById("location");
	//console.log("parentElement = " + parentElement);
	if (parentElement == null) {
		gameContent = document.getElementById("gameContent");
		statusElement = document.createElement("div");
		statusElement.setAttribute("Id", "statusx");
		statusElement.style.position = "Fixed";
		statusElement.style.top = "0px";
		statusElement.style.left = "0px";
		statusElement.style.zIndex = "1";
		
		gameContent.insertBefore(statusElement, gameContent.firstChild);
		
		parentElement = document.createElement("div");
		parentElement.setAttribute("Id", "location");
		parentElement.style.display = "none";
		statusElement.insertBefore(parentElement, statusElement.firstChild);
	}
	//parentElement = document.getElementById("location");
	//console.log("parentElement = " + parentElement);
	insertAfter(parentElement, elmBar);
		
	elmBar.style.backgroundColor = "#555";
	elmBar.style.width = "100%";
	elmBar.style.height = "auto";
	elmBar.style.position = "Static";
	//elmBar.style.paddingTop = ".5em";
	//elmBar.style.paddingBottom = ".5em";
	//elmBar.style.paddingLeft = "2%";
	//elmBar.style.paddingRight = "2%";
		
	//-----------------------Hint Button----------------------------------//
	
	//Create Element
	elm = document.createElement("a");
	elm.setAttribute("class","cmdlink commandlink");
	elm.setAttribute("data-elementid","hint");
	elm.setAttribute("data-command","hint");
	node = document.createTextNode("Hint");
	elm.setAttribute("Id","HintBtn");
	elm.appendChild(node);
	
	//Add Element to Command Bar
	parentElement = elmBar;
	parentElement.style.marginTop = "0px";
	child = parentElement.firstChild;
	parentElement.insertBefore(elm, child);
	
	//Fixed Element Styles
	elm.style.position = "static";
	elm.style.color = "#FFF";
	elm.style.textDecoration = "none";
	elm.style.display = "block";
	elm.style.textAlign = "center";
	elm.style.backgroundColor = "DarkBlue";
	elm.style.borderRadius = "5px";
	elm.style.padding = "0px";
	elm.style.cursor = "pointer";
	elm.style.cssFloat ="left";
	elm.style.lineHeight = "2em";
	elm.style.height = "2em";
	elm.style.fontSize = "1em";
	
	//Static Position
	elm.style.margin = "0px 0px 0px .5px";
	elm.style.width = "5.5em";
	
	//-----------------------Map Button----------------------------------//
	
	//Create Element
	elm = document.createElement("a");
	elm.setAttribute("class","cmdlink commandlink");
	elm.setAttribute("data-elementid","map");
	elm.setAttribute("data-command","map");
	node = document.createTextNode("Map");
	elm.setAttribute("Id","MapBtn");
	elm.appendChild(node);
	
	//Add Element to Command Bar
	parentElement = elmBar;
	parentElement.style.marginTop = "0px";
	child = parentElement.firstChild;
	parentElement.insertBefore(elm, child);
	
	//Fixed Element Styles
	elm.style.position = "static";
	elm.style.color = "#FFF";
	elm.style.textDecoration = "none";
	elm.style.display = "block";
	elm.style.textAlign = "center";
	elm.style.backgroundColor = "DarkBlue";
	elm.style.borderRadius = "5px";
	elm.style.padding = "0px";
	elm.style.cursor = "pointer";
	elm.style.cssFloat ="left";
	elm.style.lineHeight = "2em";
	elm.style.height = "2em";
	elm.style.fontSize = "1em";
	
	//Static Position
	elm.style.margin = "0px 0px 0px .5px";
	elm.style.width = "5.5em";
	
		//-----------------------Inventory Button----------------------------------//
	
	//Create Element
	elm = document.createElement("a");
	elm.setAttribute("class","cmdlink commandlink");
	elm.setAttribute("data-elementid","inventory");
	elm.setAttribute("data-command","inventory");
	node = document.createTextNode("Inventory");
	elm.setAttribute("Id","InventoryBtn");
	elm.appendChild(node);
	
	//Add Element to Command Bar
	parentElement = elmBar;
	parentElement.style.marginTop = "0px";
	child = parentElement.firstChild;
	parentElement.insertBefore(elm, child);
	
	//Fixed Element Styles
	elm.style.position = "static";
	elm.style.color = "#FFF";
	elm.style.textDecoration = "none";
	elm.style.display = "block";
	elm.style.textAlign = "center";
	elm.style.backgroundColor = "DarkBlue";
	elm.style.borderRadius = "5px";
	elm.style.padding = "0px";
	elm.style.cursor = "pointer";
	elm.style.cssFloat ="left";
	elm.style.lineHeight = "2em";
	elm.style.height = "2em";
	elm.style.fontSize = "1em";
	
	//Static Position
	elm.style.margin = "0px 0px 0px .5px";
	elm.style.width = "5.5em";
	
	//-----------------------Look Button----------------------------------//
	
	//Create Element
	elm = document.createElement("a");
	elm.setAttribute("class","cmdlink commandlink");
	elm.setAttribute("data-elementid","look");
	elm.setAttribute("data-command","look");
	node = document.createTextNode("Look");
	elm.setAttribute("Id","LookBtn");
	elm.appendChild(node);
	
	//Add Element to Command Bar
	parentElement = elmBar;
	parentElement.style.marginTop = "0px";
	child = parentElement.firstChild;
	parentElement.insertBefore(elm, child);
	
	//Fixed Element Styles
	elm.style.position = "static";
	elm.style.color = "#FFF";
	elm.style.textDecoration = "none";
	elm.style.display = "block";
	elm.style.textAlign = "center";
	elm.style.backgroundColor = "DarkBlue";
	elm.style.borderRadius = "5px";
	elm.style.padding = "0px";
	elm.style.cursor = "pointer";
	elm.style.cssFloat ="left";
	elm.style.lineHeight = "2em";
	elm.style.height = "2em";
	elm.style.fontSize = "1em";
	
	//Static Position
	elm.style.margin = "0px 0px 0px .5px";
	elm.style.width = "5.5em";
	
	
	//-----------------------Clear Bar----------------------------------//
	
	clearBar = document.createElement("div");
	parentElement = document.getElementById("HintBtn");
	insertAfter(parentElement, clearBar);
	clearBar.style.clear = "Both";
	
	ResponsiveWindow();
	
}

function ResponsiveWindow (){
	
	// Sets the break point
	miniWidth = convertEm(28);
	
	//Resize Hint Button
	resizer = document.getElementById("HintBtn");
	if (window.innerWidth < miniWidth)
	{
	  resizer.style.margin = "0px 2% .5em 2%";
	  resizer.style.width = "46%";
	} else {
	  resizer.style.margin = ".5em 0px .5em .5em";
	  resizer.style.width = "5.5em";
	}
	
	//Resize Map Button
	resizer = document.getElementById("MapBtn");
	if (window.innerWidth < miniWidth)
	{
	  resizer.style.margin = "0px 2% .5em 2%";
	  resizer.style.width = "46%";
	} else {
	  resizer.style.margin = ".5em 0px .5em .5em";
	  resizer.style.width = "5.5em";
	}
	
	//Resize Inventory Button
	resizer = document.getElementById("InventoryBtn");
	if (window.innerWidth < miniWidth)
	{
	  resizer.style.margin = ".5em 2% .5em 2%";
	  resizer.style.width = "46%";
	} else {
	  resizer.style.margin = ".5em 0px .5em .5em";
	  resizer.style.width = "5.5em";
	}
	
	//Resize Look Button
	resizer = document.getElementById("LookBtn");
	if (window.innerWidth < miniWidth)
	{
	  resizer.style.margin = ".5em 2% .5em 2%";
	  resizer.style.width = "46%";
	} else {
	  resizer.style.margin = ".5em 0px .5em .5em";
	  resizer.style.width = "5.5em";
	}
	
	
	
	
	//-----------------------resize main areas---------------//
	elm = document.getElementById("gameBorder");
	elm2 = document.getElementById("status");
	if (elm2 == null) {
		elm2 = document.getElementById("statusx");
	}
	elm3 = document.getElementById("CMDButtons");
	
	
	miniWidth = convertEm(50);
	
	if (window.innerWidth < miniWidth)
	{
		elm.style.width = "100%";
		elm.style.border = "none";
		elm2.style.width = "100%";
		elm3.style.width = "100%";
	} else {
		elm.style.width = miniWidth+"px";
		elm.style.margin = "0px auto";
		elm.style.border = "2px solid black";
		elm.style.borderTopWidth = "0px";
		elm.style.borderBottomWidth = "0px";
		elm2.style.width = miniWidth+"px";
		elm3.style.width = miniWidth+"px";
	}
	
	//-------adjust padding-top divOutput (main display area)------//
	
	statusBar = document.getElementById("status");
	if (statusBar == null) {
		statusBar = document.getElementById("CMDButtons").clientHeight;
	} else {
		statusBar = document.getElementById("status").clientHeight;
	}
	//statusBar = statusBar + convertEm(2);
	//statusBar = statusBar/2;
	
	elm = document.getElementById("divOutput");
	elm.style.position = "relative";
	elm.style.padding =  statusBar+"px 0px 0px 0px";
	elm.style.margin = "0px";
}


// Establish UI
function setUI() {
	elm = document.getElementById("gameBorder");
	elm.style.width = "100%";
	elm.style.border = "none";
	elm.style.backgroundColor = "#FFF";
	elm.style.paddingBottom = "1.5em"
	
	elm = document.getElementById("gameContent");
	elm.style.width = "96%";
	elm.style.padding = "40px 2% 0px 2%";
	
	elm = document.getElementById("status");
	elm.style.width = "100%";
	elm.style.border = "none";
	elm.style.display = "block";
	elm.style.backgroundImage = "none";
	elm.style.backgroundColor = "#000";
	elm.style.position = "fixed";
	elm.style.top = "0px";
	elm.style.height = "auto";
	
	elm = document.getElementById("location");
	if (elm == null) {
		elm = document.getElementById("locationx");
	}
	elm.style.color = "#FFF";
	
	document.body.style.backgroundColor="#222";
	
	//-----------------------resize main areas---------------//
	elm = document.getElementById("gameBorder");
	elm2 = document.getElementById("status");
	if (elm2 == null) {
		elm2 = document.getElementById("statusx");
	}
	
	miniWidth = convertEm(50);
	
	if (window.innerWidth < miniWidth)
	{
		elm.style.width = "100%";
		elm.style.border = "none";
		elm2.style.width = "100%";
	} else {
		elm.style.width = miniWidth+"px";
		elm.style.margin = "0px auto";
		elm.style.border = "2px solid black";
		elm.style.borderTopWidth = "0px";
		elm.style.borderBottomWidth = "0px";
		elm2.style.width = miniWidth+"px";
	}
	
	//-------adjust padding-top divOutput (main display area)------//
	
	statusBar = document.getElementById("status").clientHeight;
	if (statusBar == null) {
		statusBar = document.getElementById("statusx");
	}
	//statusBar = statusBar + convertEm(2);
	//statusBar = statusBar/2;
	
	elm = document.getElementById("divOutput");
	elm.style.position = "relative";
	elm.style.padding =  statusBar+"px 0px 0px 0px";
	elm.style.margin = "0px";
}